Index: /branches/UKMO/dev_r5518_AMM15_package/NEMOGCM/TOOLS/SIREN/src/grid.f90
===================================================================
--- /branches/UKMO/dev_r5518_AMM15_package/NEMOGCM/TOOLS/SIREN/src/grid.f90	(revision 10250)
+++ /branches/UKMO/dev_r5518_AMM15_package/NEMOGCM/TOOLS/SIREN/src/grid.f90	(revision 10251)
@@ -149,5 +149,5 @@
 !>    CALL grid_check_coincidence(td_coord0, td_coord1, 
 !>                                id_imin0, id_imax0, id_jmin0, id_jmax0
-!>                                ,id_rho)
+!>                                [,id_rho])
 !> @endcode
 !>       - td_coord0 is coarse grid coordinate mpp structure
@@ -161,5 +161,5 @@
 !>       - id_jmax0  is coarse grid upper right corner j-indice of fine grid 
 !> domain 
-!>       - id_rho    is array of refinement factor 
+!>       - id_rho    is array of refinement factor (default 1)
 !>
 !>    to add ghost cell at boundaries:<br/>
@@ -213,6 +213,4 @@
 !> @date October, 2014
 !> - use mpp file structure instead of file
-!> @date February, 2015
-!> - add function grid_fill_small_msk to fill small domain inside bigger one
 !
 !> @note Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -257,5 +255,4 @@
    PUBLIC :: grid_split_domain         !< compute closed sea domain 
    PUBLIC :: grid_fill_small_dom       !< fill small closed sea with fill value 
-   PUBLIC :: grid_fill_small_msk       !< fill small domain inside bigger one 
 
                                      ! get closest coarse grid indices of fine grid domain
@@ -355,5 +352,5 @@
    !> @note need all processor files to be there
    !> @author J.Paul
-   !> @date October, 2014 - Initial Version
+   !> - October, 2014- Initial Version
    !>
    !> @param[inout] td_file file structure 
@@ -469,7 +466,7 @@
    !> - compute East West overlap
    !>
-   !> @note need all processor files
+   !> @note need all processor files to be there
    !> @author J.Paul
-   !> @date October, 2014 - Initial Version
+   !> - October, 2014- Initial Version
    !>
    !> @param[in] td_mpp mpp structure 
@@ -499,5 +496,4 @@
       il_ew   =-1
 
-      CALL logger_info("GRID GET INFO: look for "//TRIM(td_mpp%c_name))
       ! copy structure
       tl_mpp=mpp_copy(td_mpp)
@@ -527,11 +523,9 @@
       ENDIF
 
-      CALL logger_info("GRID GET INFO: perio "//TRIM(fct_str(il_perio)))
-
       SELECT CASE(il_perio)
       CASE(3,4)
+         il_pivot=0
+      CASE(5,6)
          il_pivot=1
-      CASE(5,6)
-         il_pivot=0
       CASE(0,1,2)
          il_pivot=1
@@ -540,5 +534,4 @@
       IF( il_pivot < 0 .OR. il_pivot > 1 )THEN
          ! get pivot
-         CALL logger_info("GRID GET INFO: look for pivot ")
          il_pivot=grid_get_pivot(tl_mpp)
       ENDIF
@@ -546,5 +539,4 @@
       IF( il_perio < 0 .OR. il_perio > 6 )THEN
          ! get periodicity
-         CALL logger_info("GRID GET INFO: look for perio ")
          il_perio=grid_get_perio(tl_mpp, il_pivot)
       ENDIF
@@ -552,5 +544,4 @@
       IF( il_ew < 0 )THEN
          ! get periodicity
-         CALL logger_info("GRID GET INFO: look for overlap ")
          il_ew=grid_get_ew_overlap(tl_mpp)
       ENDIF
@@ -604,5 +595,5 @@
    !>
    !> @author J.Paul
-   !> @date November, 2013 - Initial version
+   !> - November, 2013- Subroutine written
    !> @date September, 2014
    !> - add dummy loop in case variable not over right point.
@@ -717,5 +708,5 @@
    !> 
    !> @author J.Paul
-   !> @date October, 2014 - Initial version
+   !> - October, 2014 - Initial version
    !
    !> @param[in] dd_value array of value
@@ -792,5 +783,5 @@
 
          IF( ll_check )THEN
-            CALL logger_info("GRID GET PIVOT: F-pivot")
+            CALL logger_info("GRID GET PIVOT: T-pivot")
             grid__get_pivot_varT=0
          ENDIF
@@ -810,5 +801,5 @@
    !> 
    !> @author J.Paul
-   !> @date October, 2014 - Initial version
+   !> - October, 2014 - Initial version
    !
    !> @param[in] dd_value array of value
@@ -885,5 +876,5 @@
 
          IF( ll_check )THEN
-            CALL logger_info("GRID GET PIVOT: F-pivot")
+            CALL logger_info("GRID GET PIVOT: T-pivot")
             grid__get_pivot_varU=0
          ENDIF
@@ -903,5 +894,5 @@
    !> 
    !> @author J.Paul
-   !> @date October, 2014 - Initial version
+   !> - October, 2014 - Initial version
    !
    !> @param[in] dd_value array of value
@@ -978,5 +969,5 @@
 
          IF( ll_check )THEN
-            CALL logger_info("GRID GET PIVOT: F-pivot")
+            CALL logger_info("GRID GET PIVOT: T-pivot")
             grid__get_pivot_varV=0
          ENDIF
@@ -996,5 +987,5 @@
    !> 
    !> @author J.Paul
-   !> @date October, 2014 - Initial version
+   !> - October, 2014 - Initial version
    !
    !> @param[in] dd_value array of value
@@ -1071,5 +1062,5 @@
 
          IF( ll_check )THEN
-            CALL logger_info("GRID GET PIVOT: F-pivot")
+            CALL logger_info("GRID GET PIVOT: T-pivot")
             grid__get_pivot_varF=0
          ENDIF
@@ -1092,5 +1083,5 @@
    !>
    !> @author J.Paul
-   !> @date Ocotber, 2014 - Initial version
+   !> - Ocotber, 2014- Initial version
    !
    !> @param[in] td_file file structure
@@ -1181,5 +1172,5 @@
    !>
    !> @author J.Paul
-   !> @date October, 2014 - Initial version
+   !> - October, 2014 - Initial version
    !
    !> @param[in] td_mpp   mpp file structure
@@ -1286,13 +1277,13 @@
    !> 1: cyclic east-west boundary
    !> 2: symmetric boundary condition across the equator
-   !> 3: North fold boundary (with a T-point pivot)
-   !> 4: North fold boundary (with a T-point pivot) and cyclic east-west boundary
-   !> 5: North fold boundary (with a F-point pivot)
-   !> 6: North fold boundary (with a F-point pivot) and cyclic east-west boundary
+   !> 3: North fold boundary (with a F-point pivot)
+   !> 4: North fold boundary (with a F-point pivot) and cyclic east-west boundary
+   !> 5: North fold boundary (with a T-point pivot)
+   !> 6: North fold boundary (with a T-point pivot) and cyclic east-west boundary
    !>
    !> @warning pivot point should have been computed before run this script. see grid_get_pivot.
    !>
    !> @author J.Paul
-   !> @date November, 2013 - Initial version
+   !> - November, 2013- Subroutine written
    !> @date October, 2014
    !> - work on variable structure instead of file structure
@@ -1461,5 +1452,5 @@
    !>
    !> @author J.Paul
-   !> @date October, 2014 - Initial version
+   !> - October, 2014 - Initial version
    !>
    !> @param[in] td_file   file structure
@@ -1546,13 +1537,13 @@
    !> 1: cyclic east-west boundary
    !> 2: symmetric boundary condition across the equator
-   !> 3: North fold boundary (with a T-point pivot)
-   !> 4: North fold boundary (with a T-point pivot) and cyclic east-west boundary
-   !> 5: North fold boundary (with a F-point pivot)
-   !> 6: North fold boundary (with a F-point pivot) and cyclic east-west boundary
+   !> 3: North fold boundary (with a F-point pivot)
+   !> 4: North fold boundary (with a F-point pivot) and cyclic east-west boundary
+   !> 5: North fold boundary (with a T-point pivot)
+   !> 6: North fold boundary (with a T-point pivot) and cyclic east-west boundary
    !>
    !> @warning pivot point should have been computed before run this script. see grid_get_pivot.
    !>
    !> @author J.Paul
-   !> @date October, 2014 - Initial version
+   !> - October, 2014 - Initial version
    !
    !> @param[in] td_mpp   mpp file structure
@@ -1643,5 +1634,5 @@
    !
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !> @date October, 2014
    !> - work on mpp file structure instead of file structure
@@ -1755,5 +1746,5 @@
    !>
    !> @author J.Paul
-   !> @date October, 2014 - Initial Version
+   !> - October, 2014- Initial Version
    !>
    !> @param[in] td_file file structure 
@@ -1806,5 +1797,5 @@
    !
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !> @date October, 2014
    !> - work on mpp file structure instead of file structure
@@ -1862,5 +1853,5 @@
    !>
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !>
    !> @param[in] td_lat latitude variable structure 
@@ -1899,5 +1890,5 @@
    !
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !> @date October, 2014
    !> - work on mpp file structure instead of file structure
@@ -1987,12 +1978,9 @@
    !>
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !> @date September, 2014
    !> - use grid point to read coordinates variable. 
    !> @date October, 2014
    !> - work on mpp file structure instead of file structure
-   !> @date February, 2015
-   !> - use longitude or latitude as standard name, if can not find 
-   !> longitude_T, latitude_T...
    !>
    !> @param[in] td_coord0 coarse grid coordinate mpp structure
@@ -2016,25 +2004,24 @@
 
       ! local variable
-      CHARACTER(LEN= 1)                        :: cl_point
-      CHARACTER(LEN=lc)                        :: cl_name
-
-      INTEGER(i4)                              :: il_imin0
-      INTEGER(i4)                              :: il_imax0
-      INTEGER(i4)                              :: il_jmin0
-      INTEGER(i4)                              :: il_jmax0
-      INTEGER(i4)                              :: il_ind
-
-      INTEGER(i4), DIMENSION(2,2)              :: il_xghost0
-      INTEGER(i4), DIMENSION(2,2)              :: il_xghost1
-
-      INTEGER(i4), DIMENSION(:)  , ALLOCATABLE :: il_rho
-
-      TYPE(TVAR)                               :: tl_lon0
-      TYPE(TVAR)                               :: tl_lat0
-      TYPE(TVAR)                               :: tl_lon1
-      TYPE(TVAR)                               :: tl_lat1
-
-      TYPE(TMPP)                               :: tl_coord0
-      TYPE(TMPP)                               :: tl_coord1
+      TYPE(TMPP) :: tl_coord0
+      TYPE(TMPP) :: tl_coord1
+
+      TYPE(TVAR)  :: tl_lon0
+      TYPE(TVAR)  :: tl_lat0
+      TYPE(TVAR)  :: tl_lon1
+      TYPE(TVAR)  :: tl_lat1
+
+      INTEGER(i4), DIMENSION(:), ALLOCATABLE :: il_rho
+
+      INTEGER(i4), DIMENSION(2,2)         :: il_xghost0
+      INTEGER(i4), DIMENSION(2,2)         :: il_xghost1
+
+      INTEGER(i4) :: il_imin0
+      INTEGER(i4) :: il_imax0
+      INTEGER(i4) :: il_jmin0
+      INTEGER(i4) :: il_jmax0
+
+      CHARACTER(LEN= 1) :: cl_point
+      CHARACTER(LEN=lc) :: cl_name
 
       ! loop indices
@@ -2070,21 +2057,6 @@
          ! read coarse longitue and latitude
          WRITE(cl_name,*) 'longitude_'//TRIM(cl_point)
-         il_ind=var_get_id(tl_coord0%t_proc(1)%t_var(:), cl_name)
-         IF( il_ind == 0 )THEN
-            CALL logger_warn("GRID GET COARSE INDEX: no variable "//&
-            &  TRIM(cl_name)//" in file "//TRIM(tl_coord0%c_name)//". &
-            &  try to use longitude.")
-            WRITE(cl_name,*) 'longitude'
-         ENDIF
          tl_lon0=iom_mpp_read_var(tl_coord0, TRIM(cl_name))
-
          WRITE(cl_name,*) 'latitude_'//TRIM(cl_point)
-         il_ind=var_get_id(tl_coord0%t_proc(1)%t_var(:), cl_name)
-         IF( il_ind == 0 )THEN
-            CALL logger_warn("GRID GET COARSE INDEX: no variable "//&
-            &  TRIM(cl_name)//" in file "//TRIM(tl_coord0%c_name)//". &
-            &  try to use latitude.")
-            WRITE(cl_name,*) 'latitude'
-         ENDIF
          tl_lat0=iom_mpp_read_var(tl_coord0, TRIM(cl_name))
          
@@ -2105,21 +2077,6 @@
          ! read fine longitue and latitude
          WRITE(cl_name,*) 'longitude_'//TRIM(cl_point)
-         il_ind=var_get_id(tl_coord1%t_proc(1)%t_var(:), cl_name)
-         IF( il_ind == 0 )THEN
-            CALL logger_warn("GRID GET COARSE INDEX: no variable "//&
-            &  TRIM(cl_name)//" in file "//TRIM(tl_coord1%c_name)//". &
-            &  try to use longitude.")
-            WRITE(cl_name,*) 'longitude'
-         ENDIF
          tl_lon1=iom_mpp_read_var(tl_coord1, TRIM(cl_name)) 
-
          WRITE(cl_name,*) 'latitude_'//TRIM(cl_point)
-         il_ind=var_get_id(tl_coord1%t_proc(1)%t_var(:), cl_name)
-         IF( il_ind == 0 )THEN
-            CALL logger_warn("GRID GET COARSE INDEX: no variable "//&
-            &  TRIM(cl_name)//" in file "//TRIM(tl_coord1%c_name)//". &
-            &  try to use latitude.")
-            WRITE(cl_name,*) 'latitude'
-         ENDIF
          tl_lat1=iom_mpp_read_var(tl_coord1, TRIM(cl_name))
  
@@ -2170,12 +2127,9 @@
    !>
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !> @date September, 2014
    !> - use grid point to read coordinates variable.
    !> @date October, 2014
    !> - work on mpp file structure instead of file structure
-   !> @date February, 2015
-   !> - use longitude or latitude as standard name, if can not find 
-   !> longitude_T, latitude_T...
    !>
    !> @param[in] td_longitude0   coarse grid longitude
@@ -2200,17 +2154,15 @@
 
       ! local variable
-      CHARACTER(LEN= 1)                        :: cl_point
-      CHARACTER(LEN=lc)                        :: cl_name
-
-      INTEGER(i4)                              :: il_ind
-
-      INTEGER(i4), DIMENSION(:)  , ALLOCATABLE :: il_rho
-
-      INTEGER(i4), DIMENSION(2,2)              :: il_xghost
-
-      TYPE(TVAR)                               :: tl_lon1
-      TYPE(TVAR)                               :: tl_lat1
-
-      TYPE(TMPP)                               :: tl_coord1
+      TYPE(TMPP)  :: tl_coord1
+
+      TYPE(TVAR)  :: tl_lon1
+      TYPE(TVAR)  :: tl_lat1
+
+      INTEGER(i4), DIMENSION(:), ALLOCATABLE :: il_rho
+
+      INTEGER(i4), DIMENSION(2,2)       :: il_xghost
+
+      CHARACTER(LEN= 1) :: cl_point
+      CHARACTER(LEN=lc) :: cl_name
 
       ! loop indices
@@ -2257,21 +2209,6 @@
          ! read fine longitue and latitude
          WRITE(cl_name,*) 'longitude_'//TRIM(cl_point)
-         il_ind=var_get_id(tl_coord1%t_proc(1)%t_var(:), cl_name)
-         IF( il_ind == 0 )THEN
-            CALL logger_warn("GRID GET COARSE INDEX: no variable "//&
-            &  TRIM(cl_name)//"in file "//TRIM(tl_coord1%c_name)//". &
-            &  try to use longitude.")
-            WRITE(cl_name,*) 'longitude'
-         ENDIF
          tl_lon1=iom_mpp_read_var(tl_coord1, TRIM(cl_name))
-
          WRITE(cl_name,*) 'latitude_'//TRIM(cl_point)
-         il_ind=var_get_id(tl_coord1%t_proc(1)%t_var(:), cl_name)
-         IF( il_ind == 0 )THEN
-            CALL logger_warn("GRID GET COARSE INDEX: no variable "//&
-            &  TRIM(cl_name)//"in file "//TRIM(tl_coord1%c_name)//". &
-            &  try to use longitude.")
-            WRITE(cl_name,*) 'latitude'
-         ENDIF
          tl_lat1=iom_mpp_read_var(tl_coord1, TRIM(cl_name))
          
@@ -2307,12 +2244,9 @@
    !>
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !> @date September, 2014
    !> - use grid point to read coordinates variable.
    !> @date October, 2014
    !> - work on mpp file structure instead of file structure
-   !> @date February, 2015
-   !> - use longitude or latitude as standard name, if can not find 
-   !> longitude_T, latitude_T...
    !> 
    !> @param[in] td_coord0 coarse grid coordinate mpp structure
@@ -2337,21 +2271,20 @@
 
       ! local variable
-      CHARACTER(LEN= 1)                        :: cl_point
-      CHARACTER(LEN=lc)                        :: cl_name      
-
-      INTEGER(i4)                              :: il_imin0
-      INTEGER(i4)                              :: il_imax0
-      INTEGER(i4)                              :: il_jmin0
-      INTEGER(i4)                              :: il_jmax0
-      INTEGER(i4)                              :: il_ind
-
-      INTEGER(i4), DIMENSION(:), ALLOCATABLE   :: il_rho
-
-      INTEGER(i4), DIMENSION(2,2)              :: il_xghost
-
-      TYPE(TVAR)                               :: tl_lon0
-      TYPE(TVAR)                               :: tl_lat0
-
-      TYPE(TMPP)                               :: tl_coord0
+      TYPE(TMPP)  :: tl_coord0
+
+      TYPE(TVAR)  :: tl_lon0
+      TYPE(TVAR)  :: tl_lat0
+
+      INTEGER(i4), DIMENSION(:), ALLOCATABLE :: il_rho
+
+      INTEGER(i4), DIMENSION(2,2)       :: il_xghost
+
+      INTEGER(i4) :: il_imin0
+      INTEGER(i4) :: il_imax0
+      INTEGER(i4) :: il_jmin0
+      INTEGER(i4) :: il_jmax0
+
+      CHARACTER(LEN= 1) :: cl_point
+      CHARACTER(LEN=lc) :: cl_name      
 
       ! loop indices
@@ -2397,21 +2330,6 @@
          ! read coarse longitue and latitude
          WRITE(cl_name,*) 'longitude_'//TRIM(cl_point)
-         il_ind=var_get_id(tl_coord0%t_proc(1)%t_var(:), cl_name)
-         IF( il_ind == 0 )THEN
-            CALL logger_warn("GRID GET COARSE INDEX: no variable "//&
-            &  TRIM(cl_name)//"in file "//TRIM(tl_coord0%c_name)//". &
-            &  try to use longitude.")
-            WRITE(cl_name,*) 'longitude'
-         ENDIF
          tl_lon0=iom_mpp_read_var(tl_coord0, TRIM(cl_name))
-         
          WRITE(cl_name,*) 'latitude_'//TRIM(cl_point)
-         il_ind=var_get_id(tl_coord0%t_proc(1)%t_var(:), cl_name)
-         IF( il_ind == 0 )THEN
-            CALL logger_warn("GRID GET COARSE INDEX: no variable "//&
-            &  TRIM(cl_name)//"in file "//TRIM(tl_coord0%c_name)//". &
-            &  try to use latitude.")
-            WRITE(cl_name,*) 'latitude'
-         ENDIF
          tl_lat0=iom_mpp_read_var(tl_coord0, TRIM(cl_name))
 
@@ -2459,5 +2377,5 @@
    !>
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !> @date September, 2014
    !> - check grid point
@@ -2602,5 +2520,5 @@
             CALL grid_del_ghost(tl_lon0, il_xghost0(:,:))
             CALL grid_del_ghost(tl_lat0, il_xghost0(:,:))
- 
+            
             ! "global" coarse grid indice
             il_imin0=1
@@ -2650,10 +2568,4 @@
             IF( dl_lon1_ll == tl_lon1%d_fill .OR. &
             &   dl_lat1_ll == tl_lat1%d_fill )THEN
-               CALL logger_debug("GRID GET COARSE INDEX: lon "//&
-               &  TRIM(fct_str(dl_lon1_ll))//" "//&
-               &  TRIM(fct_str(tl_lon1%d_fill)) )
-               CALL logger_debug("GRID GET COARSE INDEX: lat "//&
-               &  TRIM(fct_str(dl_lat1_ll))//" "//&
-               &  TRIM(fct_str(tl_lat1%d_fill)) )
                CALL logger_error("GRID GET COARSE INDEX: lower left corner "//&
                &                 "point is FillValue. remove ghost cell "//&
@@ -2720,4 +2632,5 @@
             ji = il_iul(1)
             jj = il_iul(2)
+
             IF( ABS(tl_lon0%d_value(ji,jj,1,1)-dl_lon1_ul) > dp_delta )THEN
                IF(tl_lon0%d_value(ji,jj,1,1) > dl_lon1_ul )THEN
@@ -2734,4 +2647,5 @@
                ENDIF
             ENDIF
+
             IF( ABS(tl_lat0%d_value(ji,jj,1,1)-dl_lat1_ul) > dp_delta )THEN
                IF(tl_lat0%d_value(ji,jj,1,1) < dl_lat1_ul )THEN
@@ -2884,5 +2798,5 @@
    !
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !
    !> @param[in] td_lon longitude structure 
@@ -2952,6 +2866,5 @@
    !>
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
-   !> @date February, 2015 - change dichotomy method to manage ORCA grid
+   !> - November, 2013- Initial Version
    !
    !> @param[in] dd_lon0   coarse grid array of longitude
@@ -2959,8 +2872,8 @@
    !> @param[in] dd_lon1   fine   grid longitude
    !> @param[in] dd_lat1   fine   grid latitude
-   !> @param[in] dd_fill   fill value
    !> @return coarse grid indices of closest point of fine grid point
-   !-------------------------------------------------------------------
-   FUNCTION grid_get_closest( dd_lon0, dd_lat0, dd_lon1, dd_lat1, dd_fill )
+   !>
+   !-------------------------------------------------------------------
+   FUNCTION grid_get_closest( dd_lon0, dd_lat0, dd_lon1, dd_lat1  )
       IMPLICIT NONE
       ! Argument
@@ -2969,5 +2882,4 @@
       REAL(dp),                 INTENT(IN) :: dd_lon1
       REAL(dp),                 INTENT(IN) :: dd_lat1
-      REAL(dp),                 INTENT(IN), OPTIONAL :: dd_fill
 
       ! function
@@ -3017,38 +2929,50 @@
 
       ll_north=.FALSE.
-      ll_continue=.FALSE.
-
-      ! avoid to use fillvalue for reduce domain on first time
-      IF( PRESENT(dd_fill) )THEN
-         DO WHILE( ALL(dl_lon0(il_isup,:) == dd_fill) )
-            il_isup=il_isup-1
-         ENDDO
-         DO WHILE( ALL(dl_lon0(il_iinf,:) == dd_fill) )
-            il_iinf=il_iinf+1
-         ENDDO
-         DO WHILE( ALL(dd_lat0(:,il_jsup) == dd_fill) )
-            il_jsup=il_jsup-1
-         ENDDO
-         DO WHILE( ALL(dd_lat0(:,il_jinf) == dd_fill) )
-            il_jinf=il_jinf+1
-         ENDDO
+      ll_continue=.TRUE.
+
+      ! look for meridian 0°/360°
+      il_jmid = il_jinf + INT(il_shape(2)/2)
+      il_ind(:) = MAXLOC( dl_lon0(:,il_jmid), dl_lon0(:,il_jmid) <= 360._dp )
+
+      il_imid=il_ind(1)
+
+      IF( dl_lon1 == dl_lon0(il_imid,il_jmid) .AND. &
+      &   dd_lat1 == dd_lat0(il_imid,il_jmid) )THEN
+
+         il_iinf = il_imid ;  il_isup = il_imid
+         il_jinf = il_jmid ;  il_jsup = il_jmid
+
+         ll_continue=.FALSE.
+
+      ELSE
+         IF( dl_lon1 < dl_lon0(il_isup,il_jmid) .AND. &
+         &   il_imid /= il_isup )THEN
+
+            ! point east
+            il_iinf = il_imid
+      
+         ELSE IF( dl_lon1 > dl_lon0(il_iinf,il_jmid) .AND. &
+         &        il_imid /= il_iinf )THEN
+
+            ! point west
+            il_isup = il_imid
+
+         ENDIF
 
          il_shape(1)= il_isup - il_iinf + 1
          il_shape(2)= il_jsup - il_jinf + 1
 
-      ENDIF
-
-      ! special case for north ORCA grid
-      IF( dd_lat1 > 19. .AND. dl_lon1 < 74.  )THEN
-         ll_north=.TRUE.
-      ENDIF
-
-      IF( .NOT. ll_north )THEN
-         ! look for meridian 0°/360°
+         il_imid = il_iinf + INT(il_shape(1)/2) 
          il_jmid = il_jinf + INT(il_shape(2)/2)
-         il_ind(:) = MAXLOC( dl_lon0(il_iinf:il_isup,il_jmid), &
-         &                   dl_lon0(il_iinf:il_isup,il_jmid) <= 360._dp )
-
-         il_imid=il_ind(1)
+
+         ! exit if too close from north fold (safer)
+         IF( dd_lat0(il_imid,il_jmid) > 50.0 ) ll_north=.TRUE.
+
+         ! exit when close enough of point
+         IF( ANY(il_shape(:) < 10 ) ) ll_continue=.FALSE.
+      ENDIF
+
+      !
+      DO WHILE( ll_continue .AND. .NOT. ll_north )
 
          IF( dl_lon1 == dl_lon0(il_imid,il_jmid) .AND. &
@@ -3058,68 +2982,28 @@
             il_jinf = il_jmid ;  il_jsup = il_jmid
 
+            ll_continue=.FALSE.
+
          ELSE
-            IF( ALL(dl_lon0(il_isup,il_jinf:il_jsup) >  dl_lon1 ) .AND. &
-            &   il_imid /= il_isup )THEN
-               ! 0 < lon1 < lon0(isup)
+            IF( dl_lon1 > dl_lon0(il_imid,il_jmid) )THEN
+
                ! point east
-               il_iinf = il_imid+1
-               ll_continue=.TRUE.
-         
-            ELSE IF( ALL(dl_lon0(il_iinf,il_jinf:il_jsup) <  dl_lon1 ) .AND. &
-            &        il_imid /= il_iinf )THEN
-               ! lon0(iinf) < lon1 < 360
+               il_iinf = il_imid
+        
+            ELSE IF(dl_lon1 < dl_lon0(il_imid,il_jmid) )THEN
+
                ! point west
                il_isup = il_imid
-               ll_continue=.TRUE.
 
             ENDIF
 
-            il_shape(1)= il_isup - il_iinf + 1
-            il_shape(2)= il_jsup - il_jinf + 1
-
-            il_imid = il_iinf + INT(il_shape(1)/2) 
-            il_jmid = il_jinf + INT(il_shape(2)/2)
-
-            ! exit when close enough of point
-            IF( ANY(il_shape(:) < 10 ) ) ll_continue=.FALSE.
-         ENDIF
-      ENDIF
-
-      !
-      DO WHILE( ll_continue .AND. .NOT. ll_north )
-
-         ll_continue=.FALSE.
-         IF( dl_lon1 == dl_lon0(il_imid,il_jmid) .AND. &
-         &   dd_lat1 == dd_lat0(il_imid,il_jmid) )THEN
-
-            il_iinf = il_imid ;  il_isup = il_imid
-            il_jinf = il_jmid ;  il_jsup = il_jmid
-
-         ELSE
-            IF( ALL(dl_lon0(il_imid,il_jinf:il_jsup) <  dl_lon1) )THEN    
-
-               ! point east
-               il_iinf = il_imid
-               ll_continue=.TRUE.
-        
-            ELSE IF( ALL(dl_lon0(il_imid,il_jinf:il_jsup) >  dl_lon1) )THEN    
-
-               ! point west
-               il_isup = il_imid
-               ll_continue=.TRUE.
-
-            ENDIF
-
-            IF( ALL(dd_lat0(il_iinf:il_isup,il_jmid) <  dd_lat1) )THEN    
+            IF( dd_lat1 > dd_lat0(il_imid,il_jmid) )THEN
                
                ! point north
                il_jinf = il_jmid
-               ll_continue=.TRUE.
-
-            ELSE IF( ALL(dd_lat0(il_iinf:il_isup,il_jmid) > dd_lat1) )THEN    
+
+            ELSE IF(dd_lat1 < dd_lat0(il_imid,il_jmid) )THEN
 
                ! point south
                il_jsup = il_jmid
-               ll_continue=.TRUE.
             
             ENDIF
@@ -3130,4 +3014,7 @@
             il_imid = il_iinf + INT(il_shape(1)/2) 
             il_jmid = il_jinf + INT(il_shape(2)/2)
+
+            ! exit if too close from north fold (safer)
+            IF( dd_lat0(il_imid,il_jmid) > 50.0 ) ll_north=.TRUE.
 
             ! exit when close enough of point
@@ -3162,5 +3049,5 @@
    !
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !
    !> @param[in] dd_lon    grid longitude array
@@ -3168,8 +3055,7 @@
    !> @param[in] dd_lonA   longitude of point A
    !> @param[in] dd_latA   latitude  of point A
-   !> @param[in] dd_fill
    !> @return array of distance between point A and grid points.
    !-------------------------------------------------------------------
-   FUNCTION grid_distance(dd_lon, dd_lat, dd_lonA, dd_latA )
+   FUNCTION grid_distance(dd_lon, dd_lat, dd_lonA, dd_latA)
       IMPLICIT NONE
       ! Argument      
@@ -3224,10 +3110,9 @@
          DO ji=1,il_shape(1)
             IF( dl_lon(ji,jj) == dl_lonA .AND. &
-            &   dl_lat(ji,jj) == dl_latA )THEN
+            &   dl_lat(ji,jj) == dl_laTA )THEN
                grid_distance(ji,jj)=0.0
             ELSE
                dl_tmp= SIN(dl_latA)*SIN(dl_lat(ji,jj)) + &
-               &       COS(dl_latA)*COS(dl_lat(ji,jj)) * &
-               &       COS(dl_lon(ji,jj)-dl_lonA)
+               &       COS(dl_latA)*COS(dl_lat(ji,jj))*COS(dl_lon(ji,jj)-dl_lonA)
                ! check to avoid mistake with ACOS
                IF( dl_tmp < -1.0 ) dl_tmp = -1.0
@@ -3251,5 +3136,5 @@
    !
    !> @author J.Paul
-   !> @date September, 2014 - Initial Version
+   !> - September, 2014- Initial Version
    !> @date October, 2014
    !> - work on mpp file structure instead of file structure
@@ -3285,17 +3170,16 @@
 
       ! local variable
-      INTEGER(i4)                              :: il_imin0
-      INTEGER(i4)                              :: il_jmin0
-      INTEGER(i4)                              :: il_imax0
-      INTEGER(i4)                              :: il_jmax0
-      INTEGER(i4)                              :: il_ind
+      INTEGER(i4) :: il_imin0
+      INTEGER(i4) :: il_jmin0
+      INTEGER(i4) :: il_imax0
+      INTEGER(i4) :: il_jmax0
       
-      INTEGER(i4), DIMENSION(:), ALLOCATABLE   :: il_rho
+      INTEGER(i4), DIMENSION(:), ALLOCATABLE :: il_rho
       
-      INTEGER(i4), DIMENSION(2,2)              :: il_xghost0
-      INTEGER(i4), DIMENSION(2,2)              :: il_xghost1
-
-      CHARACTER(LEN= 1)                        :: cl_point
-      CHARACTER(LEN=lc)                        :: cl_name
+      INTEGER(i4), DIMENSION(2,2)         :: il_xghost0
+      INTEGER(i4), DIMENSION(2,2)         :: il_xghost1
+
+      CHARACTER(LEN= 1) :: cl_point
+      CHARACTER(LEN=lc) :: cl_name
 
       REAL(dp)   , DIMENSION(:,:), ALLOCATABLE :: dl_lon0
@@ -3304,11 +3188,11 @@
       REAL(dp)   , DIMENSION(:,:), ALLOCATABLE :: dl_lat1
 
-      TYPE(TVAR)                               :: tl_lon0
-      TYPE(TVAR)                               :: tl_lat0
-      TYPE(TVAR)                               :: tl_lon1
-      TYPE(TVAR)                               :: tl_lat1
-
-      TYPE(TMPP)                               :: tl_coord0
-      TYPE(TMPP)                               :: tl_coord1
+      TYPE(TVAR) :: tl_lon0
+      TYPE(TVAR) :: tl_lat0
+      TYPE(TVAR) :: tl_lon1
+      TYPE(TVAR) :: tl_lat1
+
+      TYPE(TMPP) :: tl_coord0
+      TYPE(TMPP) :: tl_coord1
       
       ! loop indices
@@ -3343,21 +3227,6 @@
          ! read coarse longitue and latitude
          WRITE(cl_name,*) 'longitude_'//TRIM(cl_point)
-         il_ind=var_get_id(tl_coord0%t_proc(1)%t_var(:), cl_name)
-         IF( il_ind == 0 )THEN
-            CALL logger_warn("GRID GET FINE OFFSET: no variable "//&
-            &  TRIM(cl_name)//" in file "//TRIM(tl_coord0%c_name)//". &
-            &  try to use longitude.")
-            WRITE(cl_name,*) 'longitude'
-         ENDIF
          tl_lon0=iom_mpp_read_var(tl_coord0, TRIM(cl_name))
-
          WRITE(cl_name,*) 'latitude_'//TRIM(cl_point)
-         il_ind=var_get_id(tl_coord0%t_proc(1)%t_var(:), cl_name)
-         IF( il_ind == 0 )THEN
-            CALL logger_warn("GRID GET FINE OFFSET: no variable "//&
-            &  TRIM(cl_name)//" in file "//TRIM(tl_coord0%c_name)//". &
-            &  try to use latitude.")
-            WRITE(cl_name,*) 'latitude'
-         ENDIF
          tl_lat0=iom_mpp_read_var(tl_coord0, TRIM(cl_name))
          
@@ -3398,21 +3267,6 @@
          ! read fine longitue and latitude
          WRITE(cl_name,*) 'longitude_'//TRIM(cl_point)
-         il_ind=var_get_id(tl_coord1%t_proc(1)%t_var(:), cl_name)
-         IF( il_ind == 0 )THEN
-            CALL logger_warn("GRID GET FINE OFFSET: no variable "//&
-            &  TRIM(cl_name)//" in file "//TRIM(tl_coord1%c_name)//". &
-            &  try to use longitude.")
-            WRITE(cl_name,*) 'longitude'
-         ENDIF
          tl_lon1=iom_mpp_read_var(tl_coord1, TRIM(cl_name))
-
          WRITE(cl_name,*) 'latitude_'//TRIM(cl_point)
-         il_ind=var_get_id(tl_coord1%t_proc(1)%t_var(:), cl_name)
-         IF( il_ind == 0 )THEN
-            CALL logger_warn("GRID GET FINE OFFSET: no variable "//&
-            &  TRIM(cl_name)//" in file "//TRIM(tl_coord1%c_name)//". &
-            &  try to use latitude.")
-            WRITE(cl_name,*) 'latitude'
-         ENDIF
          tl_lat1=iom_mpp_read_var(tl_coord1, TRIM(cl_name))
  
@@ -3464,5 +3318,5 @@
    !
    !> @author J.Paul
-   !> @date September, 2014 - Initial Version
+   !> - September, 2014- Initial Version
    !> @date October, 2014
    !> - work on mpp file structure instead of file structure
